
/* Reaktiivinen lomake
*/
import { Component } from '@angular/core';
import { FormControl, FormGroup, ReactiveFormsModule } from '@angular/forms';

@Component({
  selector: 'app-reactiveform',
  standalone: true,
  imports: [ReactiveFormsModule],
  styles: [`
      form {
          width: 250px;
      }

      label {
          float: left;
          width: 200px;
      }

      input {
          float: left;
          width: 200px;
      }

      button {
          float: left;
          margin-top: 10px;
      }
  `],
  template: `<h2>Reactiveform</h2>
  <p>Reaktiivinen lomake eroaa template-driven lomakkeesta siten, että sen tietomalli<br/>
  määritellään luokan konstruktorissa, eikä templaatissa. Lomake-elementit ovat olioita,<br/>
  jotka voivat toimia observableina ja emitoida dataa reaktiivisesti.</p>
  <p>Reaktiivinen lomake soveltuu käytettäväksi kaikissa tapauksissa, mutta se soveltuu<br/>
  erityisesti tilanteisiin, joissa lomakedata pitää lähettää reaktiivisena streamina.</p>
  <p>Lomakkeelta lähetetty data logataan konsoliin, missä se näkyy JSON-muodossa.</p>

  <p>Tässä esimerkissä reaktiivinen lomake toimii käyttäjän näkökulmasta samalla tavalla<br />
  kuin template-driven lomake, koska saatua dataa ei käytetä reaktiivisena streamina.</p>

  <form [formGroup]="formModel" (ngSubmit)="onSubmit()">
<!-- FormControl -olioon viitataan termillä formControlName -->
<label>Username:</label> <input type="text" formControlName="username">
<label>SSN:</label>      <input type="text" formControlName="ssn">
<!-- FormGroup -olioon viitataan termillä formGroupName -->
      <div formGroupName="passwordsGroup">
      <label>Password:</label>        <input type="password" formControlName="password">
      <label>Confirm password:</label> <input type="password" formControlName="pconfirm">
      </div>
      <button type="submit">Submit</button>
    </form>
  `
})
export class ReactiveformComponent {
  formModel: FormGroup;
// konstruktorissa lomakkeen tietomalli jonka muodostavat oliot
  constructor() {
    this.formModel = new FormGroup({
      'username': new FormControl(),
      'ssn': new FormControl(),
      'passwordsGroup': new FormGroup({
        'password': new FormControl(),
        'pconfirm': new FormControl()
      })
    });
  }

  onSubmit() {
    console.log(this.formModel.value);
  }
}
