/*Template-driven form jossa select -valikkoelementti.
Valikon data tuodaan koodin puolelta käyttöliittymään.
Valittu arvo tulostetaan konsoliin
*/

import { CommonModule } from '@angular/common';
import { Component } from '@angular/core';
import { FormsModule } from '@angular/forms';

@Component({
    selector: 'app-selectform',
    standalone: true,
    imports: [FormsModule, CommonModule],
    template: `
    <h2>Selectform</h2><p>Template-driven form jossa on select -lomake-elementti</p>

    <form #f="ngForm" (ngSubmit)="onSubmit(f.value)">
      <h3>Hello {{name}}</h3>
      <label>Valitse</label>
      <select [(ngModel)]="name" name="valinta">
        @for(n of names; track $index){
      <option>{{n}}</option>
        }
      </select>
      <button type="submit">Lähetä</button>
    </form>
  `
})

export class SelectformComponent {

    name: String;
    names: String[];

    constructor() {
    this.name = 'Angular';
    this.names = ['Angular', 'React', 'Vue'];
    }

    onSubmit(formData: any) {
        console.log(formData);
    }
}
