/* Itse tehty direktiivi jota voi käyttää template-driven formissa
   HTML-elementin appSsn-attribuuttina
*/
import {Directive} from '@angular/core';
import {FormControl, NG_VALIDATORS} from '@angular/forms';
/*
 * valid on true jos lomakkeelta tuleva data (value)
 * 'matchaa' säännönmukaiseen lausekkeeseen.
 * valid on ehto. Jos valid on false, palautetaan null,
 * jos se on true, palautetaan olio {ssn: true}
 */
function ssnValidator(control: FormControl): {[key: string]: any} | null {
  const value: string = control.value || '';
  const valid = value.match(/^\d{9}$/); // 9 numeroa
  return valid ? null : {ssn: true};
}

/*
 * Tehdään yllä olevasta funktiosta direktiivi jota voi käyttää
 * lomaketemplaatissa nimellä appSsn
 */
@Directive({
  selector: '[appSsn]',
  standalone: true,
  providers: [{provide: NG_VALIDATORS, useValue: ssnValidator, multi: true}]
})
export class SsnValidatorDirective {}
