/*Template-driven formissa lomakkeen tietomalli määritellään templaatissa.
ngForm -direktiivillä lomakkeesta tulee Angularin lomake. ngModel-direktiivi
tekee lomakkeen komponentista osan Angularin lomakkeen tietomallia.
Lomakkeen data vastaanotetaan koodiin (ngSubmit)-eventin bindauksella
*/

import { Component } from '@angular/core';
import { FormsModule } from '@angular/forms';

@Component({
  selector: 'app-templateform',
  standalone: true,
  imports: [FormsModule],
  styles: [`
      form {
          width: 250px;
      }

      label {
          float: left;
          width: 200px;
      }

      input {
          float: left;
          width: 200px;
      }

      button {
          float: left;
          margin-top: 10px;
      }
  `],
  template: `
    <h2>Templateform</h2><p>Template-driven form on Angularin lomakemuoto jossa lomake
    luodaan templaattiin ja lomakkeella käytetään<br>
    direktiivejä (esim. ngForm ja ngModel) määrittelemään tietomalli.</p>
    <p>Lomakkeelta lähetetty data logataan tässä konsoliin missä se näkyy oliomuodossa.</p>

    <form #f="ngForm" (ngSubmit)="onSubmit(f.value)">
      <label>Username:</label>        <input type="text"     name="username" ngModel>
      <label>SSN:</label>             <input type="text"     name="ssn"      ngModel>
      <label>Password:</label>        <input type="password" name="password" ngModel>
      <label>Confirm password:</label> <input type="password" name="pconfirm"  ngModel>
      <button type="submit">Submit</button>
    </form>
  `
})

export class TemplateformComponent {
  onSubmit(formData: any) {
    console.log(formData);
  }
}
